###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2009 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildhugemem 1
%define buildlargesmp 1
%define buildxen 1
%define kernel_version 2.6.9-89.0.9.EL
%define subversion 85

%ifnarch i686 x86_64
%define buildsmp 0
%define buildxen 0
%endif 

%ifnarch i686
%define buildhugemem 0
%endif 

%ifnarch x86_64 ia64 ppc64
%define buildlargesmp 0
%endif

Name: GFS-kernel
Version: 2.6.9
Release: %{subversion}.2%{?dist}.3
License: GPL
Group: System Environment/Kernel
Summary: GFS-kernel - The Global File System kernel modules
BuildRequires: gulm-devel dlm-devel dlm-kernheaders
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: dlm-kernel

%if %{buildsmp}
BuildRequires: kernel-smp-devel = %{kernel_version}
BuildRequires: dlm-kernel-smp
%endif

%if %{buildhugemem}
BuildRequires: kernel-hugemem-devel = %{kernel_version}
BuildRequires: dlm-kernel-hugemem
%endif

%if %{buildlargesmp}
BuildRequires: kernel-largesmp-devel = %{kernel_version}
BuildRequires: dlm-kernel-largesmp
%endif

%if %{buildxen}
BuildRequires: kernel-xenU-devel = %{kernel_version}
BuildRequires: dlm-kernel-xenU
%endif

BuildRequires: dlm-kernheaders >= 2.6.9
BuildRequires: cman-kernheaders >= 2.6.9
Conflicts: GFS <= 6.0
Conflicts: GFS-modules
Requires: kernel = %{kernel_version}
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}
ExclusiveArch: i686 ia64 x86_64 ppc64
Source0: gfs-kernel-%{version}-%{subversion}.tar.gz

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.

%package -n GFS-kernheaders
Group: Development/System
Summary: GFS kernel header files

%description -n GFS-kernheaders
The GFS kernel headers are used by the GFS tool set for compilation.

%if %{buildsmp}
%package -n GFS-kernel-smp
Group: System Environment/Kernel
Summary: GFS-kernel-smp - The Global File System kernel modules
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}
%description -n GFS-kernel-smp
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

%if %{buildhugemem}
%package -n GFS-kernel-hugemem
Group: System Environment/Kernel
Summary: GFS-kernel-hugemem - The Global File System kernel modules
Requires: kernel-hugemem = %{kernel_version}
Requires: /lib/modules/%{kernel_version}hugemem
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}

%description -n GFS-kernel-hugemem
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

%if %{buildlargesmp}
%package -n GFS-kernel-largesmp
Group: System Environment/Kernel
Summary: GFS-kernel-largesmp - The Global File System kernel modules
Requires: kernel-largesmp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}largesmp
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}

%description -n GFS-kernel-largesmp
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

%if %{buildxen}
%package -n GFS-kernel-xenU
Group: System Environment/Kernel
Summary: GFS-kernel-xenU - The Global File System kernel modules
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Provides: kernel-modules
Provides: GFS-kernel-modules = %{version}-%{release}

%description -n GFS-kernel-xenU
GFS - The Global File System is a symmetric, shared-disk, cluster file
system.
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n gfs-kernel-%{version}-%{subversion}
# Put the version information into the necessary files
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
	src/nolock/main.c src/gulm/gulm.h src/gfs/gfs.h src/harness/main.c 

################################################################################
##  THE BUILD SECTION
################################################################################
%build
ROOT_DIR_FILES=`ls`

mkdir up
mv  $ROOT_DIR_FILES up
cp -r up smp
cp -r up hugemem
cp -r up largesmp
cp -r up xenU

Build_gfs(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

        ./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	ls -l /lib/modules/%{kernel_version}$flavor/kernel/cluster/dlm.symvers
        make  DLMSYMVERFILE=/lib/modules/%{kernel_version}$flavor/kernel/cluster/dlm.symvers
}

%if %{buildup}
cd up
Build_gfs %{_target_cpu}
cd ..
%endif

%if %{buildsmp}
cd smp
Build_gfs %{_target_cpu} smp
cd ..
%endif

%if %{buildhugemem}
cd hugemem
Build_gfs %{_target_cpu} hugemem
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
Build_gfs %{_target_cpu} largesmp
cd ..
%endif

%if %{buildxen}
cd xenU
Build_gfs %{_target_cpu} xenU
cd ..
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
cd up
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}/kernel/cluster/dlm.symvers
cd ..
%endif
 
%if %{buildsmp}
cd smp
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}smp/kernel/cluster/dlm.symvers
cd ..
%endif

%if %{buildhugemem}
cd hugemem
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}hugemem/kernel/cluster/dlm.symvers
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}largesmp/kernel/cluster/dlm.symvers
cd ..
%endif

%if %{buildxen}
cd xenU
make install DESTDIR=$RPM_BUILD_ROOT DLMSYMVERFILE=/lib/modules/%{kernel_version}xenU/kernel/cluster/dlm.symvers
cd ..
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildhugemem}
%post hugemem
/sbin/depmod -e %{kernel_version}hugemem
%endif

%if %{buildlargesmp}
%post largesmp
/sbin/depmod -e %{kernel_version}largesmp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%endif

%files
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}/kernel/fs/gfs/*
/lib/modules/%{kernel_version}/kernel/fs/gfs_locking/*/*

%if %{buildsmp}
%files -n GFS-kernel-smp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}smp/kernel/fs/gfs/*
/lib/modules/%{kernel_version}smp/kernel/fs/gfs_locking/*/*
%endif

%if %{buildhugemem}
%files -n GFS-kernel-hugemem
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}hugemem/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}hugemem/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}hugemem/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}hugemem/kernel/fs/gfs/*
/lib/modules/%{kernel_version}hugemem/kernel/fs/gfs_locking/*/*
%endif

%if %{buildlargesmp}
%files -n GFS-kernel-largesmp
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}largesmp/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}largesmp/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}largesmp/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}largesmp/kernel/fs/gfs/*
/lib/modules/%{kernel_version}largesmp/kernel/fs/gfs_locking/*/*
%endif

%if %{buildxen}
%files -n GFS-kernel-xenU
%defattr(-,root,root,-)
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking
%dir /lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking/*
/lib/modules/%{kernel_version}xenU/kernel/fs/gfs/*
/lib/modules/%{kernel_version}xenU/kernel/fs/gfs_locking/*/*
%endif

%files -n GFS-kernheaders
%defattr(-,root,root,-)
%{_includedir}/linux/*

%changelog
* Thu Aug 20 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.9.EL
- Resolves: rhbz#518507

* Tue Aug 11 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.7.EL
- Resolves: rhbz#516928

* Wed Jul 08 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.3.EL
- Resolves: rhbz#510075

* Tue May 05 2009 Chris Feist <cfeist@redhat.com>
- Built for kernel-2.6.9-89.EL

* Fri Apr 03 2009 Chris Feist <cfeist@redhat.com>
- Revert part of 455696 that caused "stuck in gfs_releasepage()"
- Resolves: rhbz#455696

* Wed Mar 18 2009 Chris Feist <cfeist@redhat.com>
- Fixed assertion when running NFS on top of GFS
- Resolves: rhbz#455696

* Fri Mar 13 2009 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-82.EL kernel

* Fri Mar 06 2009 Chris Feist <cfeist@redhat.com>
- Don't cancel glocks when writing to a hidden file.
- Resolves: rhbz#487026

* Mon Dec 15 2008 Chris Feist <cfeist@redhat.com>
- stat() syscall on a file now returns the real device instead of the
  diapered device.
- Various hangs and slowdowns have been fixed.
- gfs_glock_is_locked_by_me assert message has been removed.
- Remove asserts when -EBUSY errors are returned for plock unlocks.
- Resolves: rhbz#449330 rhbz#466645 rbhz#461770 rhbz#444912 rhbz#432707

* Wed May 14 2008 Chris Feist <cfeist@redhat.com>
- Removed spurious assertion in gfs_glock_is_locked_by_me
- Resolves: rhbz#444912

* Tue May 06 2008 Chris Feist <cfeist@redhat.com>
- Skip busy plocks in unlock (Part #2)
- Resolves: rhbz#432707

* Wed Mar 19 2008 Chris Feist <cfeist@redhat.com>
- GFS-kernel modules now uses device major:minor
- Resolves: rhbz#431945

* Mon Mar 10 2008 Chris Feist <cfeist@redhat.com>
- Skip busy plocks in unlock
- Resolves: rhbz#432707

* Thu Nov 08 2007 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-67.EL kernel

* Wed Sep 05 2007 Chris Feist <cfeist@redhat.com>
- Check for a null lvb pointer before trying to memset the lvm to zero.
- Resolves: rhbz#176838

* Wed Aug 29 2007 Chris Feist <cfeist@redhat.com>
- GFS can now take advantage of settings that override the diaper devices's
  generic readahead value.
- Resolves: rhbz#230803

* Mon Aug 20 2007 Chris Feist <cfeist@redhat.com>
- Disable xen until kernel is fixed

* Fri Aug 17 2007 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-56.EL
- gfs_ondisk.h now includes uint64_t instead of __be64
- A race between GFS lookup code and VM inode cache reclaim logic has been
  fixed
- glock trimming code now works properly
- Fixed a problem which could cause hangs in the gfs jid code
- Resolves: rhbz#239523 rhbz#242720 rhbz#245776 rhbz#237678

* Fri Jan 12 2007 Chris Feist <cfeist@redhat.com>
- Added support for xenU.

* Wed Dec 20 2006 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-42.0.4.EL kernel

* Mon Apr 24 2006 Chris Feist <cfeist@redhat.com>
- Added support for largesmp.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provides GFS-kernel-modules.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleanup spec file and fix %files section.

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Nov 1 2004 Chris Feist <cfeist@redhat.com> 
- new upstream sources w/ fix for __you_cannot_kmalloc_that_much

* Mon Oct 25 2004 Chris Feist <cfeist@redhat.com> 
- new upstream sources

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com> 
- new upstream sources
- smp was building but not being packaged

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com> 
- add patch for make file

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
